//  AsReaderDemoViewController.m
//  Created by Robin on 16. 8. 22..

#import "AsReaderDemoViewController.h"
#import "TagViewController.h"
#import "SettingsController.h"
#import "GlobalDefine.h"
#import "AppDelegate.h"
#import "ModelSettings.h"
#import "Utils.h"
#import <AsReaderDockSDK/AsReaderDockSDK.h>
#import <AsReaderDockSDK/AsReaderInfoDefine.h>
#import <SVProgressHUD/SVProgressHUD.h>
#import "CSVExportTableViewController.h"
#import "FileManager.h"
#import "UploadManager.h"
#import "RainTagHelper.h"
#import "CommonPlaySound.h"
#import <AsReaderBLESDK/AsReaderBLESDK.h>

@interface AsReaderDemoViewController()<AsReaderRFIDDeviceDelegate, AsreaderBarcodeDeviceDelegate, AsReaderNFCDeviceDelegate, AsReaderDeviceDelegate>
{
    int mBatteryVal;
    BOOL mbIsCahrging;
    UIAlertController * alertLoading;
    NSMutableArray *arrDeviceList;
    NSMutableArray *barcodeArray;
    NSMutableArray *rfidArray;
    NSMutableArray *nfcArray;
    
}

#define csvInvenShow @"csvInventoryShow"
#define df_NFCDATA_HEADER_SIZE 4
#define df_NFCDATA_FOOTER_SIZE 3
#define KEY_PREV_SELECTED_MODE @"KeyPrevSelectedMode"
#define segmentButtonCount 5

#define FoundBarcodeData @"KeyBarcodeDataFound"
#define FoundRFIDData @"KeyRFIDDataFound"
#define FoundNFCData @"KeyNFCDataFound"

@property (weak, nonatomic) IBOutlet UILabel *olLabelConnectState;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *olBtnOutput;
@property (weak, nonatomic) IBOutlet UILabel *olTagCount;
@property (weak, nonatomic) IBOutlet UISegmentedControl *olModeSeg;
@property (weak, nonatomic) IBOutlet UISegmentedControl *olConnectTypeSeg;
@property (weak, nonatomic) IBOutlet UIImageView *olBattery;
@property (weak, nonatomic) IBOutlet UIButton *olBtnRead;
@property (weak, nonatomic) IBOutlet UIButton *olBtnClear;
@property (weak, nonatomic) IBOutlet UIButton *olBtnStop;
@property (weak, nonatomic) IBOutlet UIButton *olBtnBLEScan;
@property (weak, nonatomic) IBOutlet UISwitch *olSwitch;

@property (strong, nonatomic) UIButton *olBtnSettings;
@property (nonatomic, strong, readwrite) TagViewController  *tagViewController;
@property (nonatomic, strong, readwrite) SettingsController *settingsController;
@property (assign, nonatomic) NSInteger csvType;
@property (nonatomic,strong) CommonPlaySound *common;
@property (nonatomic,strong) NSString *soundPath;

@end

@implementation AsReaderDemoViewController

typedef NS_ENUM(NSInteger, SelectSegment) {
    SelectSegmentBarcode = 0,
    SelectSegmentRFID,
    SelectSegmentNFC,
    SelectSegmentDual,
    SelectSegmentRFIDLF
};

typedef NS_ENUM(NSInteger, DataType){
    DataTypeBarcode,
    DataTypeRFID,
    DataTypeNFC
};

#pragma mark - segue
//---------------------------------------------------------
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"segueTagTableView"]) {
        self.tagViewController = segue.destinationViewController;
    } else if ([segue.identifier isEqualToString:@"segueSettings"]) {
        self.settingsController = segue.destinationViewController;
    } else if ([[segue identifier] isEqualToString:csvInvenShow]) {
       CSVExportTableViewController *exportVC = segue.destinationViewController;
       if (1 == _csvType) {
           exportVC.typeStr = @"csv";
       } else {
           exportVC.typeStr = @"excel";
       }
   }
}

#pragma mark - LifeCycle
//---------------------------------------------------------
- (void)viewDidLoad
{
    [super viewDidLoad];
        
    if (@available(iOS 15.0, *)){
        UINavigationBarAppearance *appearance = [[UINavigationBarAppearance alloc] init];
        appearance.backgroundEffect = [UIBlurEffect effectWithStyle:UIBlurEffectStyleRegular];
        appearance.backgroundColor = [UIColor whiteColor];
        appearance.shadowColor = [UIColor clearColor];
        self.navigationController.navigationBar.scrollEdgeAppearance = appearance;
    }
    barcodeArray = [[NSMutableArray alloc] init];
    rfidArray = [[NSMutableArray alloc] init];
    nfcArray = [[NSMutableArray alloc] init];
    self.common = [[CommonPlaySound alloc]init];
    self.olBtnSettings = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 50, 30)];
    [self.olBtnSettings setTitle:@"More" forState:UIControlStateNormal];
    [self.olBtnSettings setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
    [self.olBtnSettings addTarget:self action:@selector(morePush) forControlEvents:UIControlEventTouchUpInside];;
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithCustomView:self.olBtnSettings];
    self.olBtnSettings.userInteractionEnabled = NO;

    /*Go to first screen when background mode*/
    AppDelegate *delegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    [delegate registerRootNavigation:self.navigationController];
    
    NSDictionary *defaults = [NSDictionary dictionaryWithObjectsAndKeys:
        @"YES", @"AutoPowerOn",
        @"YES", @"beep",
        @"YES", @"illumination",
        @"YES", @"vibration",
        @"YES", @"led",
        @"YES", @"powerOnBeep",
        @"YES", @"DefaultTriggerOn",
        @"NO", @"RSSIOn",
        @"NO", @"SymbologyPrefix",
        @"0", @"RFIDScanTagCount",
        @"0", @"RFIDScanTagTime",
        @"0", @"RFIDScanTagInventory",
        @"0", @"RFIDEncoding", nil];
    
    [[NSUserDefaults standardUserDefaults]
     registerDefaults:defaults];
    
    mbIsCahrging = NO;
    int nTagCount = (int)[[NSUserDefaults standardUserDefaults] integerForKey:@"RFIDScanTagCount"];
    int nScanTime = (int)[[NSUserDefaults standardUserDefaults] integerForKey:@"RFIDScanTagTime"];
    int nCycle = (int)[[NSUserDefaults standardUserDefaults] integerForKey:@"RFIDScanTagInventory"];
    
    BOOL isDefaultTriggerOn = [[NSUserDefaults standardUserDefaults] boolForKey:@"DefaultTriggerOn"];
    
    [AsReaderDevice setTriggerModeDefault:isDefaultTriggerOn];
    BOOL bIsRSSIOn = [[NSUserDefaults standardUserDefaults] boolForKey:@"RSSIOn"];
    [AsReaderDevice setReadRSSIMode:bIsRSSIOn];

    [[AsReaderRFIDDevice sharedInstance] setTagCount:nTagCount setScanTime:nScanTime setCycle:nCycle];
    
    arrDeviceList = [[NSMutableArray alloc] init];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
    AsReaderDevice *device = [AsReaderRFIDDevice sharedInstance];
    device.delegateDevice = self;
    device.delegateRFID = self;
    device.delegateBarcode = self;
    
    if( ![[AsReaderRFIDDevice sharedInstance] isOpened]){
        [self unPlugedState];
    }

    // when Anohter view changed mode by H/W mode change
    [self updateScanData];
    [UIDevice currentDevice].batteryMonitoringEnabled = YES;
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    AsReaderDevice *device = [AsReaderRFIDDevice sharedInstance];
    device.delegateDevice = nil;
    device.delegateRFID = nil;
    device.delegateBarcode = nil;
    // when Anohter view changed mode by H/W mode change
//    [self updateScanData];
    [UIDevice currentDevice].batteryMonitoringEnabled = NO;
}

#pragma mark - Private method
//---------------------------------------------------------
- (void)morePush
{
    [self performSegueWithIdentifier:@"morepush" sender:self];
}

- (void)setConnectCommand:(BOOL)isConnect
{
    /* Check stting value (RFID, Barcode) */
    int nSectedType = (int)self.olModeSeg.selectedSegmentIndex;
    BOOL isBeepOn = [[NSUserDefaults standardUserDefaults] boolForKey:@"beep"];
    BOOL isVirbOn = [[NSUserDefaults standardUserDefaults] boolForKey:@"vibration"];
    BOOL isLedOn = [[NSUserDefaults standardUserDefaults] boolForKey:@"led"];
    BOOL isIllumOn =[[NSUserDefaults standardUserDefaults] boolForKey:@"illumination"];
    BOOL isConnectedBeep =[[NSUserDefaults standardUserDefaults] boolForKey:@"powerOnBeep"];
    [[NSUserDefaults standardUserDefaults] setInteger: self.olModeSeg.selectedSegmentIndex  forKey:KEY_PREV_SELECTED_MODE];
    
    AsReaderDevice *device = [AsReaderRFIDDevice sharedInstance];
    [device setReaderPower:isConnect beep:isBeepOn vibration:isVirbOn led:isLedOn illumination:isIllumOn connectedBeep:isConnectedBeep mode:nSectedType];
    
//    res = [device setReaderPower:isConnect beep:isBeepOn vibration:isVirbOn led:isLedOn illumination:isIllumOn mode:nSectedType];
}

- (NSArray *)getDataType
{
    NSMutableArray *array = [NSMutableArray array];
    
    for( int i=0; i<[ModelSettings sharedInstance].m_arReadTagData.count; i++) {
        NSDictionary *comDic = [[ModelSettings sharedInstance].m_arReadTagData objectAtIndex:i];
        NSInteger deviceMode = [[comDic objectForKey:df_CELL_TAG_DEVICE_MODE] integerValue];
        
        switch (deviceMode) {
            case ReaderModeBarcode:
                if( [array containsObject:FoundBarcodeData]==NO ){
                    [array addObject:FoundBarcodeData];
                }
                break;

            case ReaderModeRFID:
            case ReaderModeRFIDLF:
                if( [array containsObject:FoundRFIDData]==NO ){
                    [array addObject:FoundRFIDData];
                }
                break;
                
            case ReaderModeNFC:
                if( [array containsObject:FoundNFCData]==NO ){
                    [array addObject:FoundNFCData];
                }
                break;
                
            case ReaderModeDual:
                if( [AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeBarcode ){
                    if( [array containsObject:FoundBarcodeData]==NO ){
                        [array addObject:FoundBarcodeData];
                    }
                } else if( [AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeRFID ){
                    if( [array containsObject:FoundRFIDData]==NO ){
                        [array addObject:FoundRFIDData];
                    }
                }
                break;
            default:
                break;
        }
        
        if( [array containsObject:FoundBarcodeData]==YES &&
            [array containsObject:FoundRFIDData]==YES &&
            [array containsObject:FoundNFCData]==YES ){
            return array;
        }
    }
    
    return array;
}

- (void)csvExport
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [SVProgressHUD showWithStatus:@"Outputing..."];
        
        NSArray *checkDataArray = [self getDataType];
        
        if ( checkDataArray.count==0 ) {
            [SVProgressHUD dismiss];
            [Utils showAlert:@"" message:@"Please scan data." view:self];
            return;
        }
        
        NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
        [formatter setDateFormat:@"yyyyMMddHHmmss"];
        NSString *comfromTimeStr = [formatter stringFromDate:[NSDate date]];
        NSMutableArray * outputArray = [[NSMutableArray alloc] init];
       
        FileManager *manager = [FileManager sharedInstance];
        
        if( [checkDataArray containsObject:FoundBarcodeData]==YES ){
            NSString *barcodeName = [NSString stringWithFormat:@"barcode_%@.csv", comfromTimeStr];
            
            if( [manager exportCSV:barcodeName dataArray:barcodeArray]==NO ){
                [SVProgressHUD dismiss];
                [Utils showAlert:@"ERROR" message:@"Barcode CSV File Output Error" view:self];
                return;
            }
            [outputArray addObject:barcodeName];
        }
        
        if( [checkDataArray containsObject:FoundRFIDData]==YES ){
            NSString *rfidName = [NSString stringWithFormat:@"rfid_%@.csv", comfromTimeStr];
            if( [manager exportCSV:rfidName dataArray:rfidArray]==NO ){
                [SVProgressHUD dismiss];
                [Utils showAlert:@"ERROR" message:@"RFID CSV File Output Error" view:self];
                return;
            }
            [outputArray addObject:rfidName];
        }
        
        if( [checkDataArray containsObject:FoundNFCData]==YES ){
            NSString *nfcName = [NSString stringWithFormat:@"nfc_%@.csv",comfromTimeStr];
            if( [manager exportCSV:nfcName dataArray:nfcArray]==NO ){
                [SVProgressHUD dismiss];
                [Utils showAlert:@"ERROR" message:@"NFC CSV File Output Error" view:self];
                return;
            }
            [outputArray addObject:nfcName];
        }
        
        [SVProgressHUD dismiss];
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"CSV File Output Success" message:@"Whether to use FTP or SMB to export the file." preferredStyle:UIAlertControllerStyleAlert];
        
        UIAlertAction* okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
            [self uploadWithFileNameArray:outputArray];
        }];
        
        UIAlertAction* cancel = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {
        }];
        
        [alert addAction:okAction];
        [alert addAction:cancel];
            [self presentViewController:alert animated:YES completion:nil];
    });
}

- (void)excelExport
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [SVProgressHUD showWithStatus:@"Outputing..."];
        
        NSArray *checkDataArray = [self getDataType];
        
        if ( checkDataArray.count==0 ) {
            [SVProgressHUD dismiss];
            [Utils showAlert:@"" message:@"Please scan data." view:self];
            return;
        }
        
        NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
        [formatter setDateFormat:@"yyyyMMddHHmmss"];
        NSString *comfromTimeStr = [formatter stringFromDate:[NSDate date]];
        
        NSMutableArray *outputArray = [[NSMutableArray alloc] init];
        
        FileManager *manager = [FileManager sharedInstance];
        
        if( [checkDataArray containsObject:FoundBarcodeData]==YES ){
            NSString *barcodeName = [NSString stringWithFormat:@"barcode_%@.xlsx", comfromTimeStr];
    
            if( [manager exportExcel:barcodeName dataArray:barcodeArray]==NO ){
                [SVProgressHUD dismiss];
                [Utils showAlert:@"ERROR" message:@"Excel File Barcode Output Error" view:self];
                return;
            }
            [outputArray addObject:barcodeName];
        }
        
        if( [checkDataArray containsObject:FoundRFIDData]==YES ){
            NSString *rfidName = [NSString stringWithFormat:@"rfid_%@.xlsx", comfromTimeStr];
            if( [manager exportExcel:rfidName dataArray:rfidArray]==NO ){
                [SVProgressHUD dismiss];
                [Utils showAlert:@"ERROR" message:@"RFID CSV File Output Error" view:self];
                return;
            }
            [outputArray addObject:rfidName];
        }
        
        if( [checkDataArray containsObject:FoundNFCData]==YES ){
            NSString *nfcName = [NSString stringWithFormat:@"nfc_%@.xlsx", comfromTimeStr];
            if( [manager exportExcel:nfcName dataArray:nfcArray]==NO ){
                [SVProgressHUD dismiss];
                [Utils showAlert:@"ERROR" message:@"NFC CSV File Output Error" view:self];
                return;
            }
            [outputArray addObject:nfcName];
        }
    
        [SVProgressHUD dismiss];
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"Excel File Output Success" message:@"Whether to use FTP or SMB to export the file." preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction* okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
            [self uploadWithFileNameArray:outputArray];
        }];
        UIAlertAction* cancel = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {
        }];
        [alert addAction:okAction];
        [alert addAction:cancel];
        [self presentViewController:alert animated:YES completion:nil];
        
    });
}

// Scan Data Filtering and Manage Data
-(void)addScanDataFiltering:(NSString*)strScanRead RawData:(NSData*)dataRaw RSSI:(int)nRSSI
{
    BOOL isNewData = YES;
    
    NSString *deviceMode = [NSString stringWithFormat:@"%ld", [AsReaderInfo sharedInstance].currentReaderMode];
    NSString *dataType = [NSString stringWithFormat:@"%ld", [AsReaderInfo sharedInstance].receiveDataType];
    NSString *strRSSI = @"";
    
    if(nRSSI!=0) {
        strRSSI =  [NSString stringWithFormat:@"%d",nRSSI];
    }
    
    NSDate *timeDate = [NSDate date];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    [formatter setDateFormat:@"YYYY/MM/dd HH:mm:ss"];
    
    NSString *dateTime = [formatter stringFromDate:timeDate];
  
    for(int i=0; i<[ModelSettings sharedInstance].m_arReadTagData.count;i++) {
        NSDictionary *comDic = [[ModelSettings sharedInstance].m_arReadTagData objectAtIndex:i];
        
        BOOL isSameData = NO;
       
        NSString *oldType = [comDic objectForKey:df_CELL_DATA_TYPE];
        if([oldType intValue] == ReceiveDataTypeRFID && [AsReaderInfo sharedInstance].receiveDataType == ReceiveDataTypeRFID ){
            NSData *compare1 = [comDic objectForKey:df_CELL_TAG_RAW];
            isSameData = [RainTagHelper checkSameTag1:compare1 Tag2:dataRaw];
            
        }else{
            NSString *strCompare = [comDic objectForKey:df_CELL_TAG_INFO];
            isSameData = [strCompare isEqualToString:strScanRead];
        }
        
        
        if (isSameData){
            int nCount = [[comDic objectForKey:df_CELL_TAG_COUNT] intValue]+1;
            NSString *strCount = [NSString stringWithFormat:@"%d",nCount];
            NSDictionary *inserDic = [NSDictionary dictionaryWithObjectsAndKeys:strScanRead, df_CELL_TAG_INFO,
                                      strCount, df_CELL_TAG_COUNT,
                                      dataRaw, df_CELL_TAG_RAW,
                                      strRSSI, df_CELL_TAG_RSSI,
                                      deviceMode, df_CELL_TAG_DEVICE_MODE,
                                      dateTime, df_CELL_TAG_DATETIME,
                                      dataType, df_CELL_DATA_TYPE,
                                      nil];
            
            if( [AsReaderInfo sharedInstance].currentReaderMode==ReaderModeBarcode){
                NSLog(@"[ Old BARCODE] : %@ %d",dataRaw,(int)dataRaw.length);
            }
            
            [[ModelSettings sharedInstance].m_arReadTagData replaceObjectAtIndex:i withObject:inserDic];
            [self replaceExportDictionary:inserDic];
            isNewData = FALSE;
            break;
        }
        
    }
    
    if( isNewData==YES ) {
        //[self playSound:0];
        NSString *strCount = @"1";
        
        if( [AsReaderInfo sharedInstance].currentReaderMode==ReaderModeBarcode ) {
            NSLog(@"[ New BARCODE] : %@ %d",dataRaw,(int)dataRaw.length);
        }
        NSDictionary *inserDic = [NSDictionary dictionaryWithObjectsAndKeys:strScanRead, df_CELL_TAG_INFO,
                                  strCount, df_CELL_TAG_COUNT,
                                  dataRaw, df_CELL_TAG_RAW,
                                  strRSSI, df_CELL_TAG_RSSI,
                                  deviceMode, df_CELL_TAG_DEVICE_MODE,
                                  dateTime, df_CELL_TAG_DATETIME,
                                  dataType, df_CELL_DATA_TYPE,
                                  nil];
        
        [[ModelSettings sharedInstance].m_arReadTagData addObject:inserDic];
        [self addExportDictionary:inserDic];
    }
    
    [self updateScanData];
}
- (void)replaceExportDictionary:(NSDictionary *)inserDic{
    switch ([AsReaderInfo sharedInstance].currentReaderMode) {
        case ReaderModeBarcode: {
            for (int i = 0; i<barcodeArray.count; i++) {
                if ([[inserDic objectForKey:df_CELL_TAG_INFO] isEqualToString:[[barcodeArray objectAtIndex:i] objectForKey:df_CELL_TAG_INFO]]) {
                    [barcodeArray replaceObjectAtIndex:i withObject:inserDic];
                    return;
                }
            }
        }
            break;
        case ReaderModeRFID:{
            for (int i = 0; i<rfidArray.count; i++) {
                if ([[inserDic objectForKey:df_CELL_TAG_INFO] isEqualToString:[[rfidArray objectAtIndex:i] objectForKey:df_CELL_TAG_INFO]]) {
                    [rfidArray replaceObjectAtIndex:i withObject:inserDic];
                    return;
                }
            }
        }
            break;
        case ReaderModeRFIDLF:{
            for (int i = 0; i<rfidArray.count; i++) {
                if ([[inserDic objectForKey:df_CELL_TAG_INFO] isEqualToString:[[rfidArray objectAtIndex:i] objectForKey:df_CELL_TAG_INFO]]) {
                    [rfidArray replaceObjectAtIndex:i withObject:inserDic];
                    return;
                }
            }
        }
            break;
        case ReaderModeNFC: {
            for (int i = 0; i<nfcArray.count; i++) {
                if ([[inserDic objectForKey:df_CELL_TAG_INFO] isEqualToString:[[nfcArray objectAtIndex:i] objectForKey:df_CELL_TAG_INFO]]) {
                    [nfcArray replaceObjectAtIndex:i withObject:inserDic];
                    return;
                }
            }
        }
            break;
        case ReaderModeDual:
            if ([AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeBarcode){
                for (int i = 0; i<barcodeArray.count; i++) {
                    if ([[inserDic objectForKey:df_CELL_TAG_INFO] isEqualToString:[[barcodeArray objectAtIndex:i] objectForKey:df_CELL_TAG_INFO]]) {
                        [barcodeArray replaceObjectAtIndex:i withObject:inserDic];
                        return;
                    }
                }
            } else if([AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeRFID){
                for (int i = 0; i<rfidArray.count; i++) {
                    if ([[inserDic objectForKey:df_CELL_TAG_INFO] isEqualToString:[[rfidArray objectAtIndex:i] objectForKey:df_CELL_TAG_INFO]]) {
                        [rfidArray replaceObjectAtIndex:i withObject:inserDic];
                        return;
                    }
                }
            }
            break;
        default:
            break;
    }
}
- (void)addExportDictionary:(NSDictionary *)inserDic{
    switch ([AsReaderInfo sharedInstance].currentReaderMode) {
        case ReaderModeBarcode: {
            [barcodeArray addObject:inserDic];
        }
            break;
        case ReaderModeRFID:{
            [rfidArray addObject:inserDic];
        }
            break;
        case ReaderModeRFIDLF:{
            [rfidArray addObject:inserDic];
        }
            break;
        case ReaderModeNFC:{
            [nfcArray addObject:inserDic];
        }
            break;
        case ReaderModeDual:{
            if ([AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeBarcode){
                [barcodeArray addObject:inserDic];
            } else if([AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeRFID){
                [rfidArray addObject:inserDic];
            }
        }
            break;
        default:
            break;
    }
}
- (NSString *)decodeBarcodeData:(NSData *)data
{
    NSString *changeStr = [[NSString alloc] initWithData:data encoding:NSShiftJISStringEncoding];
    
    if(changeStr == nil) {
        changeStr = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    }
    
    if(changeStr == nil) {
        changeStr = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
    }
    
    return changeStr;
}

- (ReaderMode)settingSegmentSelected:(ReaderMode)prevMode
{
    ReaderMode setMode = ReaderModeUnknown;
    
    switch (prevMode) {
        case ReaderModeBarcode:
            if( [[AsReaderInfo sharedInstance] isSupportType:SupportTypeBarcode]==YES ){
                setMode = prevMode;
                [self.olModeSeg setSelectedSegmentIndex:SelectSegmentBarcode];
            }
            break;
            
        case ReaderModeRFID:
            if( [[AsReaderInfo sharedInstance] isSupportType:SupportTypeRFID]==YES ){
                setMode = prevMode;
                [self.olModeSeg setSelectedSegmentIndex:SelectSegmentRFID];
            }
            break;
            
        case ReaderModeNFC:
            if( [[AsReaderInfo sharedInstance] isSupportType:SupportTypeNFC]==YES ){
                setMode = prevMode;
                [self.olModeSeg setSelectedSegmentIndex:SelectSegmentNFC];
            }
            break;
                
        case ReaderModeDual:
            if( [[AsReaderInfo sharedInstance] isSupportType:SupportTypeDual]==YES ){
                setMode = prevMode;
                [self.olModeSeg setSelectedSegmentIndex:SelectSegmentDual];
            }
            break;
                
        case ReaderModeRFIDLF:
            if( [[AsReaderInfo sharedInstance] isSupportType:SupportTypeRFIDLF]==YES ){
                setMode = prevMode;
                [self.olModeSeg setSelectedSegmentIndex:SelectSegmentRFIDLF];
            }
            break;
                
        default:
            break;
    }
    
    return setMode;
}

- (void)plugedState
{
    dispatch_async(dispatch_get_main_queue(), ^{
        self.olSwitch.hidden = NO;
       
        AsReaderInfo *info = [AsReaderInfo sharedInstance];
        
        if( info.isPowerOn==YES ) {
           [self.olLabelConnectState setText:@" Connected "];
        } else {
           [self.olLabelConnectState setText:@" Plugged "];
        }
        
        //#35861-Combo connection issue when AutoPower OFF
        [self.olSwitch setEnabled:YES];
        [self.olSwitch setOn:NO];
       
        NSLog(@"App Check Device type : %@", info.deviceName);
        [self setTitle:[AsReaderInfo sharedInstance].deviceName];
       
        /* Read Save Last connected Device Info*/
        ReaderMode prevMode = [[NSUserDefaults standardUserDefaults] integerForKey:KEY_PREV_SELECTED_MODE];
        
        // Initialize Segment Enable.
        if( [info isSupportType:SupportTypeBarcode]==YES ){
            NSLog(@"Support Barcode");
            [self.olModeSeg setEnabled:YES forSegmentAtIndex:SelectSegmentBarcode];
        }
       
        if( [info isSupportType:SupportTypeRFID]==YES ){
            NSLog(@"Support RFID UHF");
            [self.olModeSeg setEnabled:YES forSegmentAtIndex:SelectSegmentRFID];
        }
    
        if( [info isSupportType:SupportTypeNFC]==YES ){
            NSLog(@"Support NFC");
            [self.olModeSeg setEnabled:YES forSegmentAtIndex:SelectSegmentNFC];
        }
       
        if( [info isSupportType:SupportTypeDual]==YES ){
            NSLog(@"Support DualMode");
            [self.olModeSeg setEnabled:YES forSegmentAtIndex:SelectSegmentDual];
        }
        
        if( [info isSupportType:SupportTypeRFIDLF]==YES ){
            NSLog(@"Support RFID LF");
            [self.olModeSeg setEnabled:YES forSegmentAtIndex:SelectSegmentRFIDLF];
        }
        
        // Decide selected number of segment.
        prevMode = [self settingSegmentSelected:prevMode];
        
        if( prevMode==ReaderModeUnknown ){
            
            NSArray *supportTypeArray = [[AsReaderInfo sharedInstance] getSupportTypeArray];
            
            if(supportTypeArray.count>0 ){
                NSNumber *number = [supportTypeArray firstObject];
                prevMode = [number integerValue];
                [self settingSegmentSelected:prevMode];
            } else {
                prevMode = [[NSUserDefaults standardUserDefaults] integerForKey:KEY_PREV_SELECTED_MODE];
            }
        }
        
        // Auto Power
        BOOL isAutoPower = [[NSUserDefaults standardUserDefaults] boolForKey:@"AutoPowerOn"];
        if( isAutoPower) {
            [self.olSwitch setOn:YES];
            [self actionSwitch:self.olSwitch];
        }
   });
}

- (void)unPlugedState
{
    dispatch_async(dispatch_get_main_queue(), ^{
        self.olBattery.image = [UIImage imageNamed:@"battery.png"];
        [self disConnectedState];
        [self.olLabelConnectState setText:@" UnPlugged "];
        [self.olSwitch setOn:NO];
        [self.olSwitch setHidden:YES];
        [self setTitle:@"Unknown Device"];
        NSLog(@"App  : %@",@"UnknowDevice");
       
        for(int index=0;index<segmentButtonCount;index++ ){
            [self.olModeSeg setEnabled:NO forSegmentAtIndex:index];
        }
        [self.olModeSeg setSelectedSegmentIndex:0];
   });
}

- (void)disConnectedState
{
    [self.olLabelConnectState setTextColor:[UIColor redColor]];
    [self.olLabelConnectState setText:@" Disconnected"];
    
    if( [self.olSwitch isOn]==YES ) {
        [self.olSwitch setOn:NO];
    }
    self.olSwitch.hidden = NO;
    self.olBtnRead.hidden = YES;
    self.olBtnClear.hidden = YES;
    self.olBtnStop.hidden = YES;
    self.olBtnSettings.userInteractionEnabled = NO;
    [self.olBtnSettings setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
}

- (void)updateScanData
{
    NSString *countStr = [NSString stringWithFormat:@"%d",(int)[ModelSettings sharedInstance].m_arReadTagData.count];
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.tagViewController updateData];
        self.olTagCount.text = countStr;
    });
}

- (void)showLoadingAlert:(BOOL)isShow message:(NSString*) message
{
    dispatch_async(dispatch_get_main_queue(),^{
        if(self->alertLoading == nil){
            self->alertLoading = [Utils getLoadingAlert:@"" message:message];
        }
        
        [self->alertLoading dismissViewControllerAnimated:YES completion:nil];
        
        if(isShow)
            [self presentViewController:self->alertLoading animated:YES completion:nil];
        else
            [self->alertLoading dismissViewControllerAnimated:YES completion:nil];
    });
}

- (void)checkPowerON
{
    dispatch_async(dispatch_get_main_queue(),^{
        [self showLoadingAlert:NO message:@""];
    //    [Utils showAlert:@"Err" message:@"There is no response." view:self];
        [self.olModeSeg setEnabled:YES];
        [self.olSwitch setEnabled:YES];
    });
}

- (void)uploadWithFileNameArray:(NSArray *)fileNameArray
{
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"CSV File Output Success" message:@"Please select export data method." preferredStyle:UIAlertControllerStyleActionSheet];
    
    UIAlertAction *ftpAlertAction = [UIAlertAction actionWithTitle:@"FTP" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [self alertActionFTP:fileNameArray];
    }];
    
    UIAlertAction *smbAlertAction = [UIAlertAction actionWithTitle:@"SMB" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [self alertActionSMB:fileNameArray];
    }];
    
    UIAlertAction* cancel = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction *action) {
    }];
    
    [alert addAction:ftpAlertAction];
    [alert addAction:smbAlertAction];
    [alert addAction:cancel];
    
    [self presentViewController:alert animated:YES completion:nil];
}

- (void)alertActionSMB:(NSArray *)fileNameArray
{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"SMB" message:@"Please enter SMB information." preferredStyle:UIAlertControllerStyleAlert];
    
    UploadManager *manager = [UploadManager sharedInstance];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"IP address";
        textField.text = manager.serverURLSMB;
    }];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"username";
        textField.text = manager.serverNameSMB;
    }];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"password";
        textField.text = manager.serverPasswordSMB;
    }];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"file path";
        textField.text = manager.serverFilePathSMB;
    }];
    
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {
    }];
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
        
        NSString *errMsg = @"";
        
        NSString *severUrl = alertController.textFields[0].text;
        if( severUrl&&severUrl.length>0 ) {
            manager.serverURLSMB = severUrl;
        } else {
            errMsg = @"Please input smb server url.";
        }
        
        NSString *severName = alertController.textFields[1].text;
        if (severName&&severName.length>0) {
            manager.serverNameSMB = severName;
        } else {
            errMsg = @"Please input smb server name.";
        }
        
        NSString *severPassword = alertController.textFields[2].text;
        if (severPassword&&severPassword.length>0) {
            manager.serverPasswordSMB = severPassword;
        } else {
            errMsg = @"Please input smb server password.";
        }
        
        NSString *severFilePath = alertController.textFields[3].text;
        if (severPassword&&severFilePath.length>0) {
            manager.serverFilePathSMB = severFilePath;
        } else {
            errMsg = @"Please input smb server file path.";
        }
        
        if( [errMsg isEqualToString:@""]==YES ){
            [SVProgressHUD showWithStatus:@"Uploading..."];
            [self uploadSMBFromArray:fileNameArray];
        } else {
            [Utils showAlert:@"ERROR" message:errMsg view:self];
        }
    }];
    [alertController addAction:okAction];
    [alertController addAction:cancel];
    [self presentViewController:alertController animated:YES completion:nil];
}

- (void)uploadSMBFromArray:(NSArray *)fileNameArray
{
    if( [fileNameArray count]>0 ) {
        NSMutableArray *array = [NSMutableArray arrayWithArray:fileNameArray];
        NSString *fileName = [NSString stringWithString:[fileNameArray firstObject]];
        [array removeObject:fileName];
        
        [[UploadManager sharedInstance] uploadSMBWithFileName:fileName complete:^(NSError *error) {
            if( error ){
                [[NSOperationQueue mainQueue] addOperationWithBlock:^{
                    [SVProgressHUD dismiss];
                    
                    NSString *title = [NSString stringWithFormat: @"Upload %@ error",fileName];
                    UIAlertController * errorAlert = [UIAlertController alertControllerWithTitle:title message:[NSString stringWithFormat:@"Error: %@", error.localizedDescription] preferredStyle:UIAlertControllerStyleAlert];
                    
                    UIAlertAction *try = [UIAlertAction actionWithTitle:@"try again" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
                        [self uploadSMBFromArray:array];
                    }];
                    
                    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction *action) {
                    }];
                    
                    [errorAlert addAction:try];
                    [errorAlert addAction:cancel];
                    [self presentViewController:errorAlert animated:YES completion:nil];
                }];
                
            } else {
                if( [array count]==0 ) { // Final data
                    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
                        [SVProgressHUD dismiss];
                        [Utils showAlert:@"SUCCESS" message:@"SMB upload success." view:self];
                    }];
                } else { // Next data
                    [self uploadSMBFromArray:array];
                }
            }
        }];
    }
}

- (void)alertActionFTP:(NSArray *)fileNameArray
{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"FTP" message:@"Please enter FTP information." preferredStyle:UIAlertControllerStyleAlert];
    
    UploadManager *manager = [UploadManager sharedInstance];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"IP address";
        textField.text = manager.serverURLFTP;
    }];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"port";
        textField.text = manager.serverPortFTP;
    }];
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"username";
        textField.text = manager.serverNameFTP;
    }];
     
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.placeholder = @"password";
        textField.text = manager.serverPasswordFTP;;
    }];
    
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {
    }];
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
        NSString *errMsg = @"";
        
        NSString *severUrl = alertController.textFields[0].text;
        if( severUrl&&severUrl.length>0 ) {
            manager.serverURLFTP = severUrl;
        } else {
            errMsg = @"Please input ftp server url.";
        }
        
        NSString *severPort = alertController.textFields[1].text;
        if( severPort&&severPort.length>0 ) {
            manager.serverPortFTP = severPort;
        } else {
            errMsg = @"Please input ftp server port.";
        }
        
        NSString *severName = alertController.textFields[2].text;
        if( severName&&severName.length>0 ) {
            manager.serverNameFTP = severName;
        } else {
            errMsg = @"Please input ftp server port.";
        }
        
        NSString *severPassword = alertController.textFields[3].text;
        if( severPassword&&severPassword.length>0 ) {
            manager.serverPasswordFTP = severPassword;
        } else {
            errMsg = @"Please input ftp server password.";
        }
        
        if( [errMsg isEqualToString:@""]==YES ){
            [SVProgressHUD showWithStatus:@"Uploading..."];
            [self uploadFTPFromArray:fileNameArray];    //upload FTP
        } else {
            [Utils showAlert:@"ERROR" message:errMsg view:self];
        }
    }];
    
    [alertController addAction:okAction];
    [alertController addAction:cancel];
    [self presentViewController:alertController animated:YES completion:nil];
}

- (void)uploadFTPFromArray:(NSArray *)fileNameArray
{
    if( [fileNameArray count]>0 ) {
        NSMutableArray *array = [NSMutableArray arrayWithArray:fileNameArray];
        NSString *fileName = [NSString stringWithString:[fileNameArray firstObject]];
        [array removeObject:fileName];
        
        [[UploadManager sharedInstance] uploadFTPWithFileName:fileName complete:^(NSError *error) {
            if( error ){
                [[NSOperationQueue mainQueue] addOperationWithBlock:^{
                    [SVProgressHUD dismiss];
                    NSString *title = [NSString stringWithFormat: @"Upload %@ error",fileName];
                    UIAlertController *errorAlert = [UIAlertController alertControllerWithTitle:title message:[NSString stringWithFormat:@"Error: %@", error.localizedDescription] preferredStyle:UIAlertControllerStyleAlert];
                    
                    UIAlertAction* try = [UIAlertAction actionWithTitle:@"try again" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
                        [self uploadFTPFromArray:fileNameArray];
                    }];
                    
                    UIAlertAction* cancel = [UIAlertAction actionWithTitle:@"cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {
                    }];
                    
                    [errorAlert addAction:try];
                    [errorAlert addAction:cancel];
                    [self presentViewController:errorAlert animated:YES completion:nil];
                }];
                
            } else {
                if( [array count]==0 ) { // final data
                    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
                        [SVProgressHUD dismiss];
                        [Utils showAlert:@"Success" message:@"FTP upload success." view:self];
                    }];
                } else { // Next data
                    [self uploadFTPFromArray:array];
                }
            }
        }];
    }
}
    
#pragma mark - AsReaderDeviceDelegate
//---------------------------------------------------------
//Plug info
- (void)plugged:(BOOL)plug
{
    dispatch_async(dispatch_get_main_queue(),^{
        if( plug==YES ) {
            NSLog(@"APP plug ON");
            [self.olBtnBLEScan setBackgroundImage:[UIImage imageNamed:@"blecon"] forState:UIControlStateNormal];
            [self plugedState];
        } else {
            NSLog(@"APP plug ONFF");
            [self.olBtnBLEScan setBackgroundImage:[UIImage imageNamed:@"bledis"] forState:UIControlStateNormal];
            [self unPlugedState];
        }
    });
    
}

// recv Scan Data
- (void)receivedScanData:(NSData *)readData
{
    if(readData==nil){ return; }

    self.soundPath = [[NSUserDefaults standardUserDefaults] objectForKey:@"sound"];
    if(self.soundPath&&![@"" isEqualToString:self.soundPath] && self.soundPath.length > 0){
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            [self.common playSound:self.soundPath];
        }];
    }
    NSMutableString *strData = [[NSMutableString alloc] init] ;
    unsigned char *ptr = (unsigned char *)[readData bytes];
    
    switch ([AsReaderInfo sharedInstance].currentReaderMode) {
        case ReaderModeBarcode: {
            NSString *barcodeStr = [self decodeBarcodeData:readData];
            if(barcodeStr != nil) {
                [strData setString:barcodeStr];
            }
            NSLog(@"APP : [BARCODE] : %@ %ld", strData, [readData length]);
        }
            break;
            
        case ReaderModeRFID:
            for(int i = 0; i < readData.length; i++) {
                [strData appendFormat:@"%02x", *ptr++ & 0xFF ];
            }
            NSLog(@"APP : [RFID UHF] : %@ %ld", strData, [readData length]);
            break;
            
        case ReaderModeRFIDLF:
            for(int i = 0; i < readData.length; i++) {
                [strData appendFormat:@"%02x", *ptr++ & 0xFF ];
            }
            NSLog(@"APP : [RFID LF] : %@ %ld", strData, [readData length]);
            break;
            
        case ReaderModeNFC: {
            // NFC DATA FORMAT : STX(1) - ADDR(1) - COMMAND(1) - LEN(1)  - DATA( XX) - ETX(1) - SUM(1) - CR(1)
            int nNFCDataLen = (int)ptr[3];
            int nTotalSize = nNFCDataLen+df_NFCDATA_HEADER_SIZE+df_NFCDATA_FOOTER_SIZE;
            
            /* Check Sum */
            Byte btSum = 0x00;
            for(int i = 0; i<nNFCDataLen+df_NFCDATA_HEADER_SIZE+1; i++) {
                btSum = (Byte)(btSum+ ptr[i]);
            }
            
            if(nTotalSize != (int)readData.length) {
                //Size Check
                [strData appendFormat:@"Data Size Err"];
                
            } else if(btSum != ptr[df_NFCDATA_HEADER_SIZE+nNFCDataLen+1]) {
                //Check Sum
                [strData appendFormat:@"Check Sum Err"];
                
            } else if((ptr[0] == 0x02)&&(ptr[df_NFCDATA_HEADER_SIZE+nNFCDataLen] == 0x03)&&(nTotalSize== readData.length)) {
                //Normal NFC Data
                for(int i = 0; i<nNFCDataLen; i++){
                    [strData appendFormat:@"%02x", ptr[i+4] & 0xFF ];
                }
                
            } else {
                [strData appendFormat:@"Data Format Err"];
            }
        }
            break;
            
        case ReaderModeDual:
            // Barcode
            if([AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeBarcode ){
                NSString *barcodeStr = [self decodeBarcodeData:readData];
                if(barcodeStr != nil) {
                    [strData setString:barcodeStr];
                }
                NSLog(@"APP : [Dual BARCODE] : %@ %d", barcodeStr, (int)[readData length]);
            } else if([AsReaderInfo sharedInstance].receiveDataType==ReceiveDataTypeRFID ){
                // RFID
                for(int i = 0; i < readData.length; i++) {
                    [strData appendFormat:@"%02x", *ptr++ & 0xFF ];
                }
                NSLog(@"APP : [Dual RFID UHF] : %@", strData);
            }
            break;
            
        default:
            break;
    }
    
    NSData *data = [[NSData alloc] initWithData:readData];
    [self addScanDataFiltering:strData RawData:data RSSI:0];
}

- (void)readerConnected:(int)status
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.olSwitch setEnabled:YES];
     
        if( status==0xff ) {
            [self.olLabelConnectState setText:@"Connected"];
            [self.olLabelConnectState setTextColor:[UIColor blueColor]];
            
            self.olBtnRead.hidden = NO;
            self.olBtnClear.hidden = NO;
            self.olBtnStop.hidden = NO;
            self.olBtnOutput.enabled = YES;
            
            self.olSwitch.hidden = NO;
            if( [self.olSwitch isOn]==NO ){
                [self.olSwitch setOn:YES];
            }
            
            self.olBtnSettings.userInteractionEnabled = YES;
            [self.olBtnSettings setTitleColor:[UIColor colorWithRed:8 / 255.f green:112 / 255.f blue:214 / 255.f alpha:1] forState:UIControlStateNormal];
            
            BOOL isSymbologyPrefix = [[NSUserDefaults standardUserDefaults] boolForKey:@"SymbologyPrefix"];
            if(isSymbologyPrefix) {
                [[AsReaderBarcodeDevice sharedInstance] setSymbologyPrefix];
            }
            
            [NSThread sleepForTimeInterval:0.5];
            [self.olModeSeg setEnabled:YES];
            
        } else {
            [self disConnectedState];
        }
   });
}


-(void) responsePowerOnOff:(BOOL)isOn HWModeChange:(BOOL)isHWModeChange{
    
    if(isHWModeChange) {
        dispatch_async(dispatch_get_main_queue(), ^{
            if([AsReaderInfo sharedInstance].currentReaderMode != ReaderModeUnknown){
                [self.olModeSeg setSelectedSegmentIndex:[AsReaderInfo sharedInstance].currentReaderMode];
            }else{
                [self.olModeSeg setEnabled:NO ];
            }
        });
    }
}

- (void)pushedTriggerButton
{
    dispatch_async(dispatch_get_main_queue(),^{
        [self setTitle:@"Custom TriggerDown"];
    });
}

- (void)releasedTriggerButton
{
    dispatch_async(dispatch_get_main_queue(),^{
        [self setTitle:@"Custom TriggerDownUp"];
    });
}

- (void)checkTriggerStatus:(NSString*)strStatus
{
    dispatch_async(dispatch_get_main_queue(),^{
        [NSThread sleepForTimeInterval:0.05f];
        [self setTitle:strStatus];
    });
}

- (void)batteryReceived:(int)battery
{
    int nVal = 0;
    if(battery > 95) {
        nVal = 4;
    } else if(battery  >70) {
        nVal =3;
    } else if(battery  >45) {
        nVal =2;
    } else if(battery  > 20) {
        nVal =1;
    } else {
        nVal =0;
    }
    
    NSString *imageName;
    
    UIDevice* currentDevice = [UIDevice currentDevice];
    UIDeviceBatteryState currentState = [currentDevice batteryState];
    
    if ((currentState == UIDeviceBatteryStateCharging) || (currentState == UIDeviceBatteryStateFull)) {
        mbIsCahrging = YES;
    } else {
        mbIsCahrging = NO;
    }
    
    if (mbIsCahrging) {
        imageName =[NSString stringWithFormat:@"bat_charge_%d.png", nVal];
    } else {
        imageName =[NSString stringWithFormat:@"bat_normal_%d.png", nVal];
    }
    dispatch_async(dispatch_get_main_queue(),^{
        self.olBattery.image = [UIImage imageNamed:imageName];
    });
    
}

- (void)errorReceived:(NSData *)errorCode
{
    /* Mode Changed Error */
    Byte *b = (Byte *) [errorCode bytes];
    if((b[0] == 0x01)&&(b[1] == 0x01)&&(b[2] == 0xE9)) {
        dispatch_async(dispatch_get_main_queue(),^{
            [Utils showAlert:@"Err" message:@"Error (Mode change)" view:self];
        });
    }
}


#pragma mark - AsReaderRFIDDeviceDelegate
//---------------------------------------------------------
- (void)pcEpcRssiReceived:(NSData *)pcEpc rssi:(int)rssi
{
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        self.soundPath = [[NSUserDefaults standardUserDefaults] objectForKey:@"sound"];
        [self.common playSound:self.soundPath];
    }];
    NSMutableString *tag = [[NSMutableString alloc] init] ;
    unsigned char *ptr = (unsigned char *)[pcEpc bytes];
    
    for(int i = 0; i < pcEpc.length; i++) {
        [tag appendFormat:@"%02x", *ptr++ & 0xFF ];
    }
    [self addScanDataFiltering:tag RawData:pcEpc RSSI:rssi];
}

- (void)epcReceived:(NSData *)epc tid:(NSData *)tid
{
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        self.soundPath = [[NSUserDefaults standardUserDefaults] objectForKey:@"sound"];
        [self.common playSound:self.soundPath];
    }];
    NSMutableString *tag = [[NSMutableString alloc] init] ;
    NSMutableString *tagTid = [[NSMutableString alloc] init] ;
    
    unsigned char *ptr= (unsigned char *)[epc bytes];
    unsigned char *ptrTid= (unsigned char *)[tid bytes];
    
    for(int i = 0; i < epc.length; i++) {
        [tag appendFormat:@"%02x", *ptr++ & 0xFF ];
    }
    for(int i = 0; i < tid.length; i++) {
        [tagTid appendFormat:@"%02x", *ptrTid++ & 0xFF ];
    }
    NSLog(@" epcReceived EPC: %@ TID: %@ ",tag,tagTid);
}

#pragma mark - AsReaderNFCDDeviceDelegate
//---------------------------------------------------------
- (void)nfcRawDataReceived:(NSData *)rawData
{
    //NSLog(@"NFC RAW DATA Receive");
    // you can reiceived command about NFC type
}

- (void)allRawDataReceived:(NSData *)rawData
{
    // you can reiceived command about ALL type
}

#pragma mark - IBAction
/***********************************************************************/
- (IBAction)btnOutput:(id)sender
{
    UIAlertController *  actionAlertVC = [UIAlertController alertControllerWithTitle:nil message:nil preferredStyle:UIAlertControllerStyleActionSheet];
    
    UIAlertAction *csvAction = [UIAlertAction actionWithTitle:@"CSV Export" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [self csvExport];
    }];
    UIAlertAction *excelAction = [UIAlertAction actionWithTitle:@"Excel Export" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [self excelExport];
    }];
    UIAlertAction *excelListAction = [UIAlertAction actionWithTitle:@"Excel List" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        self->_csvType = 2;
        [self performSegueWithIdentifier:csvInvenShow sender:nil];
    }];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:nil];
    [actionAlertVC addAction:csvAction];
    [actionAlertVC addAction:excelAction];
    [actionAlertVC addAction:excelListAction];
    [actionAlertVC addAction:cancelAction];
    
    [self presentViewController:actionAlertVC animated:NO completion:nil];
}

- (IBAction)actionSwitch:(UISwitch *)sender
{
    UISwitch *sw = (UISwitch*)sender;
    [self setConnectCommand:sw.isOn];
    
    if(sw.isOn) {
        [self.olModeSeg setEnabled:NO];
    } else {
        [self.olModeSeg setEnabled:YES];
    }
    
    [self.olSwitch setEnabled:NO];
}

- (IBAction)btnRead:(UIBarButtonItem *)sender
{
    int nTagCount = [AsReaderInfo sharedInstance].count;
    int nScanTime = [AsReaderInfo sharedInstance].scanTime;
    int nCycle = [AsReaderInfo sharedInstance].cycle;
    
    BOOL bIsRSSIOn = [[NSUserDefaults standardUserDefaults] boolForKey:@"RSSIOn"];
    NSInteger selectedMode = self.olModeSeg.selectedSegmentIndex;
    
    switch (selectedMode) {
        case SelectSegmentBarcode:
            [AsReaderBarcodeDevice sharedInstance].delegateBarcode = self;
            [[AsReaderBarcodeDevice sharedInstance] startScan];
            break;
            
        case SelectSegmentRFID:
            [AsReaderRFIDDevice sharedInstance].delegateRFID = self;
            if(bIsRSSIOn) {
                [[AsReaderRFIDDevice sharedInstance] startReadTagsAndRssiWithTagNum:nTagCount maxTime:nScanTime repeatCycle:nCycle];
            } else {
                [[AsReaderRFIDDevice sharedInstance] startScan:nTagCount mtime:nScanTime repeatCycle:nCycle];
            }
            break;
            
        case SelectSegmentNFC:
            [AsReaderNFCDevice sharedInstance].delegateNFC = self;
            [[AsReaderNFCDevice sharedInstance] startScan];
            break;
            
        case SelectSegmentRFIDLF:
            [AsReaderRFIDDevice sharedInstance].delegateRFID = self;
            [[AsReaderRFIDDevice sharedInstance] startScan:nTagCount mtime:nScanTime repeatCycle:nCycle];
            break;
            
        case SelectSegmentDual:
//            [AsReaderRFIDDevice sharedInstance].delegateRFID = self;
            [[AsReaderBarcodeDevice sharedInstance] startScan];
            if(bIsRSSIOn) {
                [[AsReaderRFIDDevice sharedInstance] startReadTagsAndRssiWithTagNum:nTagCount maxTime:nScanTime repeatCycle:nCycle];
            } else {
                [[AsReaderRFIDDevice sharedInstance] startScan:nTagCount mtime:nScanTime repeatCycle:nCycle];
            }
            break;
            
        default:
            break;
    }
}

- (IBAction)btnClear:(UIBarButtonItem *)sender
{
    [[ModelSettings sharedInstance].m_arReadTagData removeAllObjects];
    [barcodeArray removeAllObjects];
    [rfidArray removeAllObjects];
    [nfcArray removeAllObjects];
    [self updateScanData];
}

- (IBAction)btnStop:(UIBarButtonItem *)sender
{
    NSInteger selectedMode = self.olModeSeg.selectedSegmentIndex;
    
    switch (selectedMode) {
        case SelectSegmentBarcode:
            NSLog(@"App Stop Barcode");
            [[AsReaderBarcodeDevice sharedInstance] stopScan];
            break;
            
        case SelectSegmentRFID:
        case SelectSegmentRFIDLF:
            NSLog(@"App Stop RFID");
            [[AsReaderRFIDDevice sharedInstance] stopScan];
            break;
            
        case SelectSegmentNFC:
            NSLog(@"App Stop NFC");
            [[AsReaderNFCDevice sharedInstance] stopScan];
            break;
            
        case SelectSegmentDual:  //add 20190518 Dual Mode
            [[AsReaderBarcodeDevice sharedInstance] stopScan];
            [[AsReaderRFIDDevice sharedInstance] stopScan];
            break;
    }
}

- (IBAction)actionModeSeg:(id)sender
{
    [self.olSwitch setEnabled:YES];
    [self.olSwitch setOn:NO];
    [self setConnectCommand:NO];
}

- (IBAction)btnNFCRawdataSend:(id)sender
{
    //Ex ) Inventory Mode set
    Byte cmd[] = NFC_CMD_INVENTORYSET;
    NSData *data = [[NSData alloc] initWithBytes:cmd length:sizeof(cmd)];
    [[AsReaderNFCDevice sharedInstance] sendData:data];
}

- (IBAction)btnScanBle:(id)sender
{
    // BLE Functions
    // TODO: Need inplements after BLE.
    if(arrDeviceList == nil)
        arrDeviceList = [NSMutableArray new];
    [arrDeviceList removeAllObjects];
    if(![[AsReaderRFIDDevice sharedInstance] isOpened])
        [[AsReaderRFIDDevice sharedInstance] startBleScan];
    else
        [[AsReaderRFIDDevice sharedInstance] disConnectBLE];
}
- (void)scanningBleDeive:(CBPeripheral*)device{
    [arrDeviceList addObject:device];
}

- (void)scanBleStatus:(BleStatusCodes)status{
    
    if(status == BLE_STS_SCANNING){
        [SVProgressHUD showWithStatus:@"Searching for device."];
    }
    
    if(status == BLE_STS_SCAN_STOP){
        [SVProgressHUD dismiss];
        if(arrDeviceList.count !=0)
            [self showAlert:@"Barcode reader connection" message:@"Please select a searched device below" datas:arrDeviceList];
        else
            [Utils showAlert:@"No reader found." message:@"Check the power of the reader." view:self];
    }
    
}

- (void)showAlert:(NSString *)title message:(NSString *)message datas:(NSArray *)bleDevices{
    
    dispatch_async(dispatch_get_main_queue(),^{
        UIAlertController *alert = [UIAlertController
                                    alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
        
        UIAlertAction* button;
        
        
        for(int i =0; i<bleDevices.count; i++) {
            CBPeripheral *device = [bleDevices objectAtIndex:i];
            button = [UIAlertAction actionWithTitle:device.name style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
                
                [[AsReaderRFIDDevice sharedInstance] connectBLE:device];
                //[self->bleDevice connectPeripheral:device];
            }];
            
            [alert addAction:button];
        }
        
        
        button = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {
            //None
        }];
        
        [alert addAction:button];
        [self presentViewController:alert animated:YES completion:nil];
    });
}


-(IBAction)segConnectionTypeEvent:(id)sender{
    
    _olConnectTypeSeg.hidden = YES;
    [self performSelector:@selector(showSegment) withObject:nil afterDelay:5.0];

    UISegmentedControl *seg = (UISegmentedControl*)sender;
    [_olBtnBLEScan setHidden:YES];
    switch (seg.selectedSegmentIndex) {
        case 0: //USB
            [AsReaderRFIDDevice sharedInstance].connectionType = ConnectionTypeUSB;
            break;
        case 1: //BLE
            [AsReaderRFIDDevice sharedInstance].connectionType = ConnectionTypeBLE;
            [_olBtnBLEScan setHidden:NO];
            break;
        default:
            break;
    }
}

- (void)showSegment {
    _olConnectTypeSeg.hidden = NO;
}

@end
